"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.rmCachedMicroApp = exports.qiankunVue2Unmount = exports.qiankunVue2Mount = exports.hasCachedMicroApp = void 0;
var _qiankunVue2Alive = require("../qiankun-vue2-alive");
function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread(); }
function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _iterableToArray(iter) { if (typeof Symbol !== "undefined" && iter[Symbol.iterator] != null || iter["@@iterator"] != null) return Array.from(iter); }
function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) return _arrayLikeToArray(arr); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; } /// <reference path="../qiankun-vue2-alive/types.js" />
/**
 * @type {MicroAppCacheMap}
 */
var microAppCache = new Map();
var microAppName = Symbol('microAppName');

/**
 * @param {string} name
 * @returns {boolean}
 */
var rmCachedMicroApp = exports.rmCachedMicroApp = function rmCachedMicroApp(name) {
  return microAppCache["delete"](name);
};

/**
 * @param {string} name
 * @returns {boolean}
 */
var hasCachedMicroApp = exports.hasCachedMicroApp = function hasCachedMicroApp(name) {
  return microAppCache.has(name);
};

/**
 * @param {object} opts
 * @param {import('vue').VueConstructor} opts.Vue
 * @param {import('vue-router').default} opts.router
 * @param {import('vue').Component} opts.App
 * @param {string} [opts.appId='#app']
 * @param {any} opts.qiankunProps
 */
var qiankunVue2Mount = exports.qiankunVue2Mount = function qiankunVue2Mount(opts) {
  var Vue = opts.Vue,
    router = opts.router,
    store = opts.store,
    App = opts.App,
    _opts$appId = opts.appId,
    appId = _opts$appId === void 0 ? '#app' : _opts$appId,
    qiankunProps = opts.qiankunProps;
  var container = qiankunProps.container,
    name = qiankunProps.name;
  var cached = microAppCache.get(name);
  Vue.component(_qiankunVue2Alive.QiankunVue2Alive.name, _qiankunVue2Alive.QiankunVue2Alive);
  if (cached) {
    router.apps = cached.$router.apps;
  }
  var vm = new Vue({
    router: router,
    store: store,
    render: cached ? function () {
      return cached._vnode;
    } : function (h) {
      return h(App);
    }
  });
  vm.$mount(container ? container.querySelector(appId) : appId);
  vm[microAppName] = name;
  return vm;
};
var qiankunVue2Unmount = exports.qiankunVue2Unmount = function qiankunVue2Unmount(vm) {
  var name = vm[microAppName];

  /**
   * @type {MicroAppCached}
   */
  var cached = microAppCache.get(name) || vm;
  var app = {
    type: 'vue2',
    _vnode: cached._vnode,
    $router: {
      // TODO: memory leak ?
      apps: _toConsumableArray(vm.$router.apps)
    }
  };
  if (!app._vnode.data.keepAlive) {
    app._vnode.data.keepAlive = true;
  }
  microAppCache.set(name, app);
  vm.$destroy();
};