"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.hitBlacklist = hitBlacklist;
var _utils = require("./utils");
/// <reference path="./types.js" />

/**
 * @param {import('vue').Component} vm
 * @param {string} k
 * @returns {boolean}
 */
function hitBlacklist(vm, k) {
  var key = k || (0, _utils.getVNodeKey)(vm);
  if (!key || typeof key !== 'string') {
    return false;
  }
  if ((0, _utils.isArray)(vm.blacklist)) {
    return vm.blacklist.some(function (target) {
      return target === key || target === key.split('?').shift();
    });
  }
  if ((0, _utils.isRegExp)(vm.blacklist)) {
    return vm.blacklist.test(key);
  }
  if ((0, _utils.isFunction)(vm.blacklist)) {
    return !!vm.blacklist(key);
  }
  return false;
}